package roberto;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.BodyContent;
import javax.servlet.jsp.tagext.BodyTag;
import javax.servlet.jsp.tagext.BodyTagSupport;
import javax.servlet.jsp.tagext.IterationTag;
import javax.servlet.jsp.tagext.Tag;
import javax.servlet.jsp.tagext.TagSupport;

public class RctagsimpleTag extends BodyTagSupport {
    private String parametro;    

    public RctagsimpleTag() {
        super();
    }

    public void otherDoStartTagOperations()  {
           try 
           {
               JspWriter out = pageContext.getOut();
               String sParametro = pageContext.getRequest().getParameter(parametro);
               
               out.println("El parmetro en la tag es: " + sParametro);
           } 
           catch (java.io.IOException ex) 
           {
               // do something
           }
     }
    
   public boolean theBodyShouldBeEvaluated()  {
       return true;

    }
    
   public void otherDoEndTagOperations()  {

    }
    
    public boolean shouldEvaluateRestOfPageAfterEndTag()  {
     return true;

    }
    
        public int doStartTag() throws JspException, JspException {
        otherDoStartTagOperations();
        
        if (theBodyShouldBeEvaluated()) {
            return EVAL_BODY_BUFFERED;
        } else {
            return SKIP_BODY;
        }
    }
    
   public int doEndTag() throws JspException, JspException {
        otherDoEndTagOperations();
        
        if (shouldEvaluateRestOfPageAfterEndTag()) {
            return EVAL_PAGE;
        } else {
            return SKIP_PAGE;
        }
    }
    
    public String getParametro() {
        return parametro;
    }
    
    public void setParametro(String value) {
        parametro = value;
    }

    public void writeTagBodyContent(JspWriter out, BodyContent bodyContent) throws IOException {
        bodyContent.writeOut(out);
        bodyContent.clearBody();
    }
    
   public void handleBodyContentException(Exception ex) throws JspException {
        // Since the doAfterBody method is guarded, place exception handing code here.
        throw new JspException("error in RctagsimpleTag: " + ex);
    }
    
  public int doAfterBody() throws JspException {
        try {
             
            JspWriter out = getPreviousOut();
            BodyContent bodyContent = getBodyContent();
            
            writeTagBodyContent(out, bodyContent);
        } catch (Exception ex) {
            handleBodyContentException(ex);
        }
        
        if (theBodyShouldBeEvaluatedAgain()) {
            return EVAL_BODY_AGAIN;
        } else {
            return SKIP_BODY;
        }
    }
    
  public boolean theBodyShouldBeEvaluatedAgain() {
       return false;
    }
}
